import React, { Component } from "react";
import Button from "react-bootstrap/esm/Button";
import Card from 'react-bootstrap/Card';
import ListGroup from 'react-bootstrap/ListGroup';

class UserItem extends Component {
    render() {
        const user = this.props.user
        let editButtonID = "UserItemEditButton" + user.userID
        let deleteButtonID = "UserItemDeleteButton" + user.userID
        let itemID = "UserItem" + user.userID
        let dialogData = {
            dialogID: "DeleteDialogUser" + user.userID,
            name: user.firstName + " " + user.lastName,
            userID: user.userID
        }
        return (
            <div>
                <Card style={{ width: "18rem", background: '#ebebeb' }} id={itemID}>
                            <Card.Header>{user.firstName} {user.lastName}</Card.Header>
                            <ListGroup variant="flush">
                                <ListGroup.Item >User ID: {user.userID}</ListGroup.Item>
                                <ListGroup.Item >First Name: {user.firstName}</ListGroup.Item>
                                <ListGroup.Item >Last Name: {user.lastName}</ListGroup.Item>
                            </ListGroup>
                            <Card.Footer style={{ display: 'flex', justifyContent: 'space-evenly'}}>
                                <Button variant="primary" onClick={(e) => this.props.handleShowEditPage(e, user)} id={editButtonID} >Edit</Button>
                                <Button variant="primary" type="submit" onClick={(e) => this.props.handleShowDeleteModal(e, dialogData)} id={deleteButtonID} style={{ background: '#ffc800', color: 'black', border: 'none' }}>
                                    Delete
                                </Button>
                            </Card.Footer>
                        </Card>
            </div>
        )
    }
}


export default UserItem